
/*
 * This program is original work by San Mehat <nettwerk@valinux.com> .
 * This program is distributed under the GNU General Public License (GPL)
 * as outlined in the COPYING file.
 *
 * Copyright (C) 1999, San Mehat, and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 */

#ifndef _NEXXUS_USERS_H
#define _NEXXUS_USERS_H

#include <config.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define GROUP_NAME_MAXLENGTH 64
typedef struct user_group
	{
	char	group_name[GROUP_NAME_MAXLENGTH];

	struct user_group	*next;
	struct user_group	*prev;
	} USER_GROUP;

typedef struct module_rule
	{
	char	ipc_glob[255];
	int		policy;

	struct module_rule	*next;
	struct module_rule	*prev;
	} MODULE_RULE;

typedef struct user_module_acl
	{
	char				module_ipc_tag[16];
	MODULE_RULE	*rules;

	struct user_module_acl	*next;
	struct user_module_acl	*prev;
	} USER_MODULE_ACL;

typedef struct user_address_rule
	{
	struct in_addr	ipv4_address;
	int							ipv4_sigbits;
	int							policy;

	struct user_address_rule	*next;
	struct user_address_rule	*prev;
	} USER_ADDRESS_RULE;

#define	POLICY_ALLOW	1
#define POLICY_DENY		2
typedef struct nexxus_user
	{
	char							user_name[64];
	char							password[42];
	int								default_module_acl_policy;
	int								default_address_acl_policy;
	USER_MODULE_ACL		*mod_acl;
	USER_ADDRESS_RULE	*addr_acl;
	USER_GROUP				*groups; // Groups the user is a member of

	struct nexxus_user	*next;
	struct nexxus_user	*prev;
	} NEXXUS_USER;
#endif
