/*
 * This program is original work by San Mehat <nettwerk@valinux.com> and
 * Zac Sprackett <zac@sprackett.com>.
 * This program is distributed under the GNU Lesser General Public License
 * (LGPL).
 *
 * Copyright (C) 1999, San Mehat, Zac Sprackett and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef _LIBLOOSE_H
#define _LIBLOOSE_H

int lm_init(void);
int lm_nexxus_connect(void);
int lm_nexxus_disconnect(void);
int lm_register(char  *short_name,
                char  *long_name,
                char  *desc,
                char  *author,
                char  *ipc_tag,
                int   major_version,
                int   minor_version);
void lm_main_loop(void (*config_cb) (__uint32_t, int, char *),
                  void (*deinit_cb) (__uint32_t, int, char *),
                  void (*discon_cb) (__uint32_t, int, char *),
                  void (*ipc_cb) (char *, __uint32_t, int, char *));
int lm_timer_add(int timeout,
                 int (*cb) (void *),
                 void *arg);
int lm_timer_remove(int tag);
int lm_watch_fd(int   I_fd,
                void  (*cb) (int, void *),
                void  *arg);
int lm_unwatch_fd(int I_fd);
int lm_send_to_nexxus(char *msg);
int lm_log(char *msg);

#endif 
