#ifndef _QUANTA_H
#define _QUANTA_H

typedef struct monitoring_data
	{
	unsigned char	cpu2_vcore;
	unsigned char	mainboard_plus_2_7;
	unsigned char	pwr_plus_3_3;
	unsigned char	pwr_plus_12;
	unsigned char	pwr_minus_12;
	unsigned char	res1;
	unsigned char	pwr_plus_5;
	unsigned char	mainboard_plus_1_5;
	unsigned char	cpu1_vcore;
	unsigned char	stndby_plus_3_3;
	unsigned char	res2;
	unsigned char	scsi_plus_2_85;
	unsigned char	sys_temp;
	unsigned char	cpu2_temp;
	unsigned char	cpu1_temp;
	unsigned char	fan1_speed;
	unsigned char	fan2_speed;
	unsigned char batt_volt_plus_3_3;
	unsigned char	stndby_plus_5;
	unsigned char	cksum;
	} M_D;

typedef struct converted_monitoring_data
	{
	float	cpu2_vcore;
	float	mainboard_plus_2_7;
	float	pwr_plus_3_3;
	float	pwr_plus_12;
	float	pwr_minus_12;
	float	pwr_plus_5;
	float	mainboard_plus_1_5;
	float	cpu1_vcore;
	float	stndby_plus_3_3;
	float	scsi_plus_2_85;
	float	sys_temp;
	float	cpu2_temp;
	float	cpu1_temp;
	float	fan1_speed;
	float	fan2_speed;
	float batt_volt_plus_3_3;
	float	stndby_plus_5;
	} C_MD;

typedef struct sensor_limits
	{
	unsigned char	cpu2_vcore_h;
	unsigned char	cpu2_vcore_l;
	unsigned char	mainboard_plus_2_7_h;
	unsigned char	mainboard_plus_2_7_l;
	unsigned char	pwr_plus_3_3_h;
	unsigned char	pwr_plus_3_3_l;
	unsigned char	pwr_plus_12_h;
	unsigned char	pwr_plus_12_l;
	unsigned char	pwr_minus_12_h;
	unsigned char	pwr_minus_12_l;
	unsigned char	pwr_plus_5_h;
	unsigned char	pwr_plus_5_l;
	unsigned char	mainboard_plus_1_5_h;
	unsigned char	mainboard_plus_1_5_l;
	unsigned char	cpu1_vcore_h;
	unsigned char	cpu1_vcore_l;
	unsigned char	stndby_plus_3_3_h;
	unsigned char	stndby_plus_3_3_l;
	unsigned char	scsi_plus_2_85_h;
	unsigned char	scsi_plus_2_85_l;
	unsigned char	sys_temp_h;
	unsigned char	cpu2_temp_h;
	unsigned char	cpu1_temp_h;
	unsigned char	fan1_speed_l;
	unsigned char	fan2_speed_l;
	unsigned char batt_volt_plus_3_3_h;
	unsigned char batt_volt_plus_3_3_l;
	unsigned char	stndby_plus_5_h;
	unsigned char	stndby_plus_5_l;
	unsigned char	cksum;
	} SENSOR_LIM;

typedef struct converted_sensor_limits
{
	float	cpu2_vcore_h;
	float	cpu2_vcore_l;
	float	mainboard_plus_2_7_h;
	float	mainboard_plus_2_7_l;
	float	pwr_plus_3_3_h;
	float	pwr_plus_3_3_l;
	float	pwr_plus_12_h;
	float	pwr_plus_12_l;
	float	pwr_minus_12_h;
	float	pwr_minus_12_l;
	float	pwr_plus_5_h;
	float	pwr_plus_5_l;
	float	mainboard_plus_1_5_h;
	float	mainboard_plus_1_5_l;
	float	cpu1_vcore_h;
	float	cpu1_vcore_l;
	float	stndby_plus_3_3_h;
	float	stndby_plus_3_3_l;
	float	scsi_plus_2_85_h;
	float	scsi_plus_2_85_l;
	float	sys_temp_h;
	float	cpu2_temp_h;
	float	cpu1_temp_h;
	float	cpu1_temp_l;
	float	fan1_speed_l;
	float	fan2_speed_l;
	float batt_volt_plus_3_3_h;
	float batt_volt_plus_3_3_l;
	float	stndby_plus_5_h;
	float	stndby_plus_5_l;
} C_SENSOR_LIM;

struct stat1
	{
	unsigned char	cpu2_vcore			:1;
	unsigned char	two_pt_five			:1;
	unsigned char	three_pt_three	:1;
	unsigned char	five						:1;
	unsigned char	sys_temp				:1;
	unsigned char	cpu2_temp				:1;
	unsigned char	fan1						:1;
	unsigned char	fan2						:1;
	};

struct stat2
	{
	unsigned char	twelve								:1;
	unsigned char	minus_twelve					:1;
	unsigned char	res1									:1;
	unsigned char	res2									:1;
	unsigned char	three_pt_three_stndby	:1;
	unsigned char	cpu1_temp							:1;
	unsigned char	cpu1_vcore						:1;
	unsigned char	five_stndby						:1;
	};

struct stat3
	{
	unsigned char	mb_one_pt_five				:1;
	unsigned char	scsi_two_pt_eightfive	:1;
	unsigned char	batt_three_pt_three		:1;
	unsigned char	chassis_intrusion			:1;
	unsigned char	cpu1_ierr							:1;
	unsigned char	cpu2_ierr							:1;
	unsigned char	cpu1_thermal_trip			:1;
	unsigned char	cpu2_thermal_trip			:1;
	};

struct stat_bios
	{
	unsigned char	mem_ecc_1bit_err			:1;
	unsigned char	mem_ecc_multibit_err	:1;
	unsigned char	pci_perr							:1;
	unsigned char	pci_serr							:1;
	unsigned char	res1									:1;
	unsigned char	res2									:1;
	unsigned char	res3									:1;
	unsigned char	res4									:1;
	};

typedef struct firmware_ver
	{
	unsigned char	major;
	unsigned char	minor;
	unsigned char cksum;
	} FW_VER;

typedef struct bmc_status
	{
	unsigned char			res1;
	struct stat1			s1;
	struct stat2			s2;
	unsigned char			hour;
	unsigned char			minute;
	unsigned char			second;
	struct stat_bios	sb;
	struct stat3			s3;
	unsigned char			cksum;
	} BMC_STAT;

typedef struct clear_sel
	{
	unsigned char res1;
	unsigned char res2;
	unsigned char	cc;
	unsigned char res3;
	unsigned char	cksum;
	} CLEAR_SEL;

typedef struct sel_info
	{
	unsigned char 	res1;
	unsigned char 	res2;
	unsigned char		res3;
	unsigned char		sel_ver;
	unsigned short	entries;
	unsigned char		cksum;
	} SEL_INFO;

typedef struct sel_entry_rq
	{
	unsigned char		hdr[3]		__attribute__((packed));
	unsigned short	record_id	__attribute__((packed));
	unsigned char		cksum			__attribute__((packed));
	} SEL_ENTRY_RQ;

typedef struct sel_entry
	{
	unsigned char		res1										__attribute__((packed));
	unsigned char		res2										__attribute__((packed));
	unsigned char		res3										__attribute__((packed));
	unsigned short	next_record_id					__attribute__((packed));
	unsigned short	record_id								__attribute__((packed));
	unsigned char		res4										__attribute__((packed));
	unsigned char		year										__attribute__((packed));
	unsigned char		month										__attribute__((packed));
	unsigned char		day											__attribute__((packed));
	unsigned char		hour										__attribute__((packed));
	unsigned char		minute									__attribute__((packed));
	unsigned char		second									__attribute__((packed));
	unsigned char		evm_rev									__attribute__((packed));
	unsigned char		sensor_type							__attribute__((packed));
	unsigned char		sensor_num							__attribute__((packed));
	unsigned char		event_reading_type			__attribute__((packed));
	unsigned char		sensor_specific_offset	__attribute__((packed));
	unsigned char		event_data							__attribute__((packed));
	unsigned char		res5										__attribute__((packed));
	unsigned char		cksum										__attribute__((packed));
	} SEL_ENTRY;

#define	CMD_GET_MONITORING_DATA	0x31
#define CMD_GET_BMC_STATUS			0x37
#define CMD_GET_FW_VERSION			0x38
#define CMD_CLEAR_SEL						0x39
#define CMD_TOGGLE_MISC_LED			0x41
#define CMD_TURN_ON_MISC_LED		0x42
#define CMD_TURN_OFF_MISC_LED		0x43
#define CMD_POWER_ON						0x44
#define CMD_POWER_OFF						0x45
#define CMD_HARDWARE_RESET			0x46
#define CMD_GET_SENSOR_LIMITS		0x47
#define CMD_PING								0x4b
#define CMD_GET_SEL_INFO				0x4c
#define CMD_GET_SEL_ENTRY				0x4d
#define CMD_BAUD_RATE_CHANGE		0x4a
#define CMD_PASS_THROUGH				0x49

#endif
